Loading...
Searching...
No Matches
BALL::VIEW::ColorUnitHue Class Reference
Visualisation » Datatypes for the VIEW framework » Format conversion classes used by the color classes

`#include <BALL/VIEW/DATATYPE/colorUnitHue.h>`

## Public Member Functions

Constructors
| ColorUnitHue ()
| ColorUnitHue (const ColorUnitHue &colcor_h_unit)
| ColorUnitHue (const char *value)
| ColorUnitHue (const String &value)
| ColorUnitHue (const short value)
| ColorUnitHue (const unsigned short value)
| ColorUnitHue (const int value)
| ColorUnitHue (const unsigned int value)
| ColorUnitHue (const long value)
| ColorUnitHue (const unsigned long value)
| ColorUnitHue (const float value)
| ColorUnitHue (const double value)
| ColorUnitHue (const long double value)
Destructors
virtual | ~ColorUnitHue ()
virtual void | clear ()
Converters
| operator String () const
| operator short () const
| operator unsigned short () const
| operator int () const
| operator unsigned int () const
| operator long () const
| operator unsigned long () const
| operator float () const
| operator double () const
| operator long double () const
Assignment methods
void | set (const ColorUnitHue &color_unit_hue)
const ColorUnitHue & | operator= (const ColorUnitHue &color_unit_hue)
void | swap (ColorUnitHue &color_unit_hue)
void | set (const char *value)
const ColorUnitHue & | operator= (const char *value)
void | get (char *value) const
void | set (const String &value)
const ColorUnitHue & | operator= (const String &value)
void | get (String &value) const
void | set (const short value)
const ColorUnitHue & | operator= (const short value)
void | get (short &value) const
void | set (const unsigned short value)
const ColorUnitHue & | operator= (const unsigned short value)
void | get (unsigned short &value) const
void | set (const int value)
const ColorUnitHue & | operator= (const int value)
void | get (int &value) const
void | set (const unsigned int value)
const ColorUnitHue & | operator= (const unsigned int value)
void | get (unsigned int &value) const
void | set (const long value)
const ColorUnitHue & | operator= (const long value)
void | get (long &value) const
void | set (const unsigned long value)
const ColorUnitHue & | operator= (const unsigned long value)
void | get (unsigned long &value) const
void | set (const float value)
const ColorUnitHue & | operator= (const float init)
void | get (float &value) const
void | set (const double value)
const ColorUnitHue & | operator= (const double value)
void | get (double &value) const
void | set (const long double value)
const ColorUnitHue & | operator= (const long double value)
void | get (long double &value) const
Predicates
bool | operator== (const ColorUnitHue &color_unit_hue) const
bool | operator!= (const ColorUnitHue &color_unit_hue) const
bool | operator< (const ColorUnitHue &color_unit_hue) const
bool | operator<= (const ColorUnitHue &color_unit_hue) const
bool | operator> (const ColorUnitHue &color_unit_hue) const
bool | operator>= (const ColorUnitHue &color_unit_hue) const
debuggers and diagnostics
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const

## Storers

std::istream & | operator>> (std::istream &s, ColorUnitHue &color_unit_hue)
std::ostream & | operator<< (std::ostream &s, const ColorUnitHue &color_unit_hue)

## Detailed Description

Value for the hue component of the class ColorHSV. The class handles the many possible variations a hue value can be set (e.g. integer, float, string values can be given as parameter). The integer values are of range 0-360, the float values are of range 0-1.0 and the strings are given in hex format "000"-"168" for the values 0-360. ColorUnitHue provides certain conversion functions as well that will convert its value to the needed type.

Definition at line 29 of file colorUnitHue.h.

## Constructor & Destructor Documentation

## ColorUnitHue() [1/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( |  | ) |

Default Constructor.

## ColorUnitHue() [2/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const ColorUnitHue & | colcor_h_unit | ) |

Copy constructor.

## ColorUnitHue() [3/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const char * | value | ) |

Constructor with Parameter char*.

Parameters

  value | the pointer to a string ( 00 - 168h)

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## ColorUnitHue() [4/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const String & | value | ) |

Constructor with Parameter String.

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## ColorUnitHue() [5/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const short | value | ) |

Constructor with Parameter short.

Parameters

  value | a short value ( 0 - 360)

Exceptions

  InvalidRange | if value < 0 || value > 360

## ColorUnitHue() [6/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const unsigned short | value | ) |

Constructor with Parameter unsigned short.

Parameters

  value | a unsigned short value ( 0 - 360)

Exceptions

  InvalidRange | if value > 360

## ColorUnitHue() [7/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const int | value | ) |

Constructor with Parameter int.

Parameters

  value | an int value ( 0 - 360)

Exceptions

  InvalidRange | if value < 0 || value > 360

## ColorUnitHue() [8/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const unsigned int | value | ) |

Constructor with Parameter unsigned int.

Parameters

  value | an unsigned int value ( 0 - 360)

Exceptions

  InvalidRange | if value > 360

## ColorUnitHue() [9/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const long | value | ) |

Constructor with Parameter long.

Parameters

  value | an long value ( 0 - 360)

Exceptions

  InvalidRange | if value < 0 || value > 360

## ColorUnitHue() [10/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const unsigned long | value | ) |

Constructor with Parameter unsigned long.

Parameters

  value | an unsigned long value ( 0 - 360)

Exceptions

  InvalidRange | if value > 360

## ColorUnitHue() [11/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const float | value | ) |

Constructor with Parameter float.

Parameters

  value | a float value ( 0 - 1.0)

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## ColorUnitHue() [12/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const double | value | ) |

Constructor with Parameter double.

Parameters

  value | a double value ( 0 - 1.0)

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## ColorUnitHue() [13/13]

BALL::VIEW::ColorUnitHue::ColorUnitHue | ( | const long double | value | ) |

Constructor with Parameter long double.

Parameters

  value | a long double value ( 0 - 1.0)

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## ~ColorUnitHue()

virtual BALL::VIEW::ColorUnitHue::~ColorUnitHue | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::VIEW::ColorUnitHue::clear | ( |  | ) |

virtual

Explicit default initialization. Sets the value to the default value (0).

## dump()

virtual void BALL::VIEW::ColorUnitHue::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal value dump. Dumps the current value to the output ostream s with dumping depth depth.

Parameters

  s | output stream where to output the value
  depth | the dumping depth (depth is irrelevant here)

## get() [1/11]

void BALL::VIEW::ColorUnitHue::get | ( | char * | value | ) | const

Inspection of the value. Accesses the value by using a char pointer. Memory must be allocated for this parameter. The memory must be at least the size of 4 bytes.

Parameters

  value | a char* receiving the value in hex format ( "00"-"168")

## get() [2/11]

void BALL::VIEW::ColorUnitHue::get | ( | double & | value | ) | const

Inspection of the value.

Parameters

  value | a double receiving the value (range: 0-1.0)

## get() [3/11]

void BALL::VIEW::ColorUnitHue::get | ( | float & | value | ) | const

Inspection of the value.

Parameters

  value | a float receiving the value (range: 0-1.0)

See also
  set

## get() [4/11]

void BALL::VIEW::ColorUnitHue::get | ( | int & | value | ) | const

Inspection of the value.

Parameters

  value | an int receiving the value (range: 0-360)

## get() [5/11]

void BALL::VIEW::ColorUnitHue::get | ( | long & | value | ) | const

Inspection of the value.

Parameters

  value | a long receiving the value (range: 0-360)

## get() [6/11]

void BALL::VIEW::ColorUnitHue::get | ( | long double & | value | ) | const

Inspection of the value.

Parameters

  value | a long double receiving the value (range: 0-1.0)

## get() [7/11]

void BALL::VIEW::ColorUnitHue::get | ( | short & | value | ) | const

Inspection of the value.

Parameters

  value | a short receiving the value (range: 0-360)

## get() [8/11]

void BALL::VIEW::ColorUnitHue::get | ( | String & | value | ) | const

Inspection of the value.

Parameters

  value | a string receiving the value in hex format ( "00"-"168")

See also
  set

## get() [9/11]

void BALL::VIEW::ColorUnitHue::get | ( | unsigned int & | value | ) | const

Inspection of the value.

Parameters

  value | an unsigned int receiving the value (range: 0-360)

## get() [10/11]

void BALL::VIEW::ColorUnitHue::get | ( | unsigned long & | value | ) | const

Inspection of the value.

Parameters

  value | an unsigned long receiving the value (range: 0-360)

## get() [11/11]

void BALL::VIEW::ColorUnitHue::get | ( | unsigned short & | value | ) | const

Inspection of the value.

Parameters

  value | an unsigned short receiving the value (range: 0-360)

## operator double()

BALL::VIEW::ColorUnitHue::operator double | ( |  | ) | const

Conversion to double.

Returns
  double with a value of range 0 - 1.0

## operator float()

BALL::VIEW::ColorUnitHue::operator float | ( |  | ) | const

Conversion to float.

Returns
  float with a value of range 0 - 1.0

## operator int()

BALL::VIEW::ColorUnitHue::operator int | ( |  | ) | const

Conversion to int.

Returns
  int with a value of range 0 - 360

## operator long()

BALL::VIEW::ColorUnitHue::operator long | ( |  | ) | const

Conversion to long.

Returns
  long with a value of range 0 - 360

## operator long double()

BALL::VIEW::ColorUnitHue::operator long double | ( |  | ) | const

Conversion to long double.

Returns
  long double with a value of range 0 - 1.0

## operator short()

BALL::VIEW::ColorUnitHue::operator short | ( |  | ) | const

Conversion to short.

Returns
  short with a value of range 0 - 360

## operator String()

BALL::VIEW::ColorUnitHue::operator String | ( |  | ) | const

Conversion to string.

Returns
  string with hex format "00"-"168"

## operator unsigned int()

BALL::VIEW::ColorUnitHue::operator unsigned int | ( |  | ) | const

Conversion to unsigned int.

Returns
  unsigned int with a value of range 0 - 360

## operator unsigned long()

BALL::VIEW::ColorUnitHue::operator unsigned long | ( |  | ) | const

Conversion to unsigned long.

Returns
  unsigned long with a value of range 0 - 360

## operator unsigned short()

BALL::VIEW::ColorUnitHue::operator unsigned short | ( |  | ) | const

Conversion to unsigned short.

Returns
  unsigned short with a value of range 0 - 360

## operator!=()

bool BALL::VIEW::ColorUnitHue::operator!= | ( | const ColorUnitHue & | color_unit_hue | ) | const

Unequality test.

## operator<()

bool BALL::VIEW::ColorUnitHue::operator< | ( | const ColorUnitHue & | color_unit_hue | ) | const

Smaller test.

## operator<=()

bool BALL::VIEW::ColorUnitHue::operator<= | ( | const ColorUnitHue & | color_unit_hue | ) | const

Smaller or equal test.

## operator=() [1/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const char * | value | ) |

Assignment operator with char*. Calls set.

Parameters

  value | the pointer to a string containing a value in hex format ( "00"-"168")

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## operator=() [2/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const ColorUnitHue & | color_unit_hue | ) |

Assignment operator.

## operator=() [3/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const double | value | ) |

Assignment operator with double. Calls set.

Parameters

  value | a double containing a value of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## operator=() [4/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const float | init | ) |

Assignment operator with float. Calls set.

Parameters

  init | a float containing a value of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## operator=() [5/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const int | value | ) |

Assignment operator with int. Calls set.

Parameters

  value | an int containing a value of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## operator=() [6/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const long double | value | ) |

Assignment operator with long double. Calls set.

Parameters

  value | a long double containing a value of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## operator=() [7/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const long | value | ) |

Assignment operator with long. Calls set.

Parameters

  value | a long containing a value of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## operator=() [8/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const short | value | ) |

Assignment operator with short. Calls set.

Parameters

  value | a short containing a value of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## operator=() [9/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const String & | value | ) |

Assignment operator with string. Calls set.

Parameters

  value | a string containing a value in hex format ( "00"-"168")

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## operator=() [10/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const unsigned int | value | ) |

Assignment operator with unsigned int. Calls set.

Parameters

  value | an unsigned int containing a value of range 0-360

Exceptions

  InvalidRange | if value > 360

## operator=() [11/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const unsigned long | value | ) |

Assignment operator with unsigned long. Calls set.

Parameters

  value | an unsigned long containing a value of range 0-360

Exceptions

  InvalidRange | if value > 360

## operator=() [12/12]

const ColorUnitHue & BALL::VIEW::ColorUnitHue::operator= | ( | const unsigned short | value | ) |

Assignment operator with unsigned short. Calls set.

Parameters

  value | an unsigned short containing a value of range 0-360

Exceptions

  InvalidRange | if value > 360

## operator==()

bool BALL::VIEW::ColorUnitHue::operator== | ( | const ColorUnitHue & | color_unit_hue | ) | const

Equality test.

## operator>()

bool BALL::VIEW::ColorUnitHue::operator> | ( | const ColorUnitHue & | color_unit_hue | ) | const

Greater test.

## operator>=()

bool BALL::VIEW::ColorUnitHue::operator>= | ( | const ColorUnitHue & | color_unit_hue | ) | const

Greater or equal test.

## set() [1/12]

void BALL::VIEW::ColorUnitHue::set | ( | const char * | value | ) |

Changes the value to the value represented by a pointer value to a string.

Parameters

  value | the new value (a string in the format "00"-"168")

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## set() [2/12]

void BALL::VIEW::ColorUnitHue::set | ( | const ColorUnitHue & | color_unit_hue | ) |

Assignment.

## set() [3/12]

void BALL::VIEW::ColorUnitHue::set | ( | const double | value | ) |

Changes the value.

Parameters

  value | a double of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## set() [4/12]

void BALL::VIEW::ColorUnitHue::set | ( | const float | value | ) |

Changes the value.

Parameters

  value | a float of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## set() [5/12]

void BALL::VIEW::ColorUnitHue::set | ( | const int | value | ) |

Changes the value .

Parameters

  value | an int of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## set() [6/12]

void BALL::VIEW::ColorUnitHue::set | ( | const long double | value | ) |

Changes the value.

Parameters

  value | a long double of range 0-1.0

Exceptions

  InvalidRange | if value < 0.0 || value > 1.0

## set() [7/12]

void BALL::VIEW::ColorUnitHue::set | ( | const long | value | ) |

Changes the value.

Parameters

  value | a long of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## set() [8/12]

void BALL::VIEW::ColorUnitHue::set | ( | const short | value | ) |

Changes the value .

Parameters

  value | a short of range 0-360

Exceptions

  InvalidRange | if value < 0 || value > 360

## set() [9/12]

void BALL::VIEW::ColorUnitHue::set | ( | const String & | value | ) |

Changes the value .

Parameters

  value | a string (in the hex format "00"-"168")

Exceptions

  InvalidRange | if string length > 3
  NotInHexFormat | if string contains characters g-z or G-Z or the hex number exceeds 168h

## set() [10/12]

void BALL::VIEW::ColorUnitHue::set | ( | const unsigned int | value | ) |

Changes the value.

Parameters

  value | an unsigned int of range 0-360

Exceptions

  InvalidRange | if value > 360

## set() [11/12]

void BALL::VIEW::ColorUnitHue::set | ( | const unsigned long | value | ) |

Changes the value.

Parameters

  value | an unsigned long of range 0-360

Exceptions

  InvalidRange | if value > 360

## set() [12/12]

void BALL::VIEW::ColorUnitHue::set | ( | const unsigned short | value | ) |

Changes the value .

Parameters

  value | an unsigned short of range 0-360

Exceptions

  InvalidRange | if value > 360

## swap()

void BALL::VIEW::ColorUnitHue::swap | ( | ColorUnitHue & | color_unit_hue | ) |

Swapping of colorUnitHues.

## Friends And Related Symbol Documentation

## operator<<

std::ostream & operator<< | ( | std::ostream & | s,
|  | const ColorUnitHue & | color_unit_hue )

friend

Friend stream output. Writes colorUnitHue data to the output stream s and store the value of this. The value will be stored in integer format of range 0-360. This method is provided for convienience.

Parameters

  s | output stream to where the value will be stored
  color_unit_hue | the colorUnitHue from which the value will be stored

## operator>>

std::istream & operator>> | ( | std::istream & | s,
|  | ColorUnitHue & | color_unit_hue )

friend

Friend stream input. Reads colorUnitHue data from the input stream s and restore the value of this. The value will be needed in integer format of range 0-360. This method is provided for convienience.

Parameters

  s | input stream from where to restore the value
  color_unit_hue | the colorUnitHue to which the value will be restored